<?xml version="1.0" encoding="utf-8"?>
<xbrl
  xmlns="http://www.xbrl.org/2003/instance"
  xmlns:dei="http://xbrl.sec.gov/dei/2022"
  xmlns:link="http://www.xbrl.org/2003/linkbase"
  xmlns:xlink="http://www.w3.org/1999/xlink">
    <link:schemaRef xlink:href="gnty-20230117.xsd" xlink:type="simple"/>
    <context id="C_dbfb670b-9b74-4811-a238-df4dbaefbf50">
        <entity>
            <identifier scheme="http://www.sec.gov/CIK">0001058867</identifier>
        </entity>
        <period>
            <startDate>2023-01-17</startDate>
            <endDate>2023-01-17</endDate>
        </period>
    </context>
    <dei:AmendmentFlag
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_0e35c891-9eac-4e8b-9115-5900888fcf2c">false</dei:AmendmentFlag>
    <dei:EntityCentralIndexKey
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_e0debdf7-74c3-49af-af97-00c5e3f7082a">0001058867</dei:EntityCentralIndexKey>
    <dei:DocumentType
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_fe24ea8e-7818-4e0c-8fa3-f6dd3adabeb3">8-K</dei:DocumentType>
    <dei:DocumentPeriodEndDate
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_89381200-4a56-40df-b0a8-23399881c79c">2023-01-17</dei:DocumentPeriodEndDate>
    <dei:EntityRegistrantName
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_db3142b2-58f7-4091-a663-60aaa1b1c9b5">GUARANTY BANCSHARES, INC.</dei:EntityRegistrantName>
    <dei:EntityIncorporationStateCountryCode
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_281689c4-3a89-474d-9637-414335243930">TX</dei:EntityIncorporationStateCountryCode>
    <dei:EntityFileNumber
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_794f5ac0-7bdd-4b3d-81e4-066c441833ab">001-38087</dei:EntityFileNumber>
    <dei:EntityTaxIdentificationNumber
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_a86818a2-1941-431a-8c6d-eed5f4ecb668">75-1656431</dei:EntityTaxIdentificationNumber>
    <dei:EntityAddressAddressLine1
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_9d98e211-2d8d-46ac-ae52-8693e1ce2946">16475 Dallas Parkway</dei:EntityAddressAddressLine1>
    <dei:EntityAddressAddressLine2
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_62dbc6e4-05cd-4d73-9dd3-98bdf22ed43d">Suite 600</dei:EntityAddressAddressLine2>
    <dei:EntityAddressCityOrTown
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_4c6eb503-6123-40e2-a48e-73e8f5832aa0">Addison</dei:EntityAddressCityOrTown>
    <dei:EntityAddressStateOrProvince
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_a9b33b05-99e7-4315-baaf-b0ddbe3115d4">TX</dei:EntityAddressStateOrProvince>
    <dei:EntityAddressPostalZipCode
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_b3735fdc-9e08-4756-b539-8497d1c7ff78">75001</dei:EntityAddressPostalZipCode>
    <dei:CityAreaCode
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_223df086-63bc-4527-ac60-2a4b4f740803">888</dei:CityAreaCode>
    <dei:LocalPhoneNumber
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_b3abc247-5a5d-46f4-9b36-e6afeaaf36e1">572-9881</dei:LocalPhoneNumber>
    <dei:WrittenCommunications
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_45ef8448-8c1b-4c15-a0b9-bdb33ad5296f">false</dei:WrittenCommunications>
    <dei:SolicitingMaterial
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_fa44ec64-76a6-406b-b182-a3b9f8ee30bb">false</dei:SolicitingMaterial>
    <dei:PreCommencementTenderOffer
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_3ff74c4b-5fa3-4062-8fed-04a2f4942de0">false</dei:PreCommencementTenderOffer>
    <dei:PreCommencementIssuerTenderOffer
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_2af8018e-5bfe-4dff-87f7-9e92eda67726">false</dei:PreCommencementIssuerTenderOffer>
    <dei:Security12bTitle
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_fbfe5b6d-bf94-4ba8-b55f-a292f9734939">Common Stock, par value $1.00 per share </dei:Security12bTitle>
    <dei:TradingSymbol
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_127629bd-34f4-4fc1-9c9d-2291c725bee6">GNTY</dei:TradingSymbol>
    <dei:SecurityExchangeName
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_3f9e215e-6a40-4943-9f5f-da26ba2eb86b">NASDAQ</dei:SecurityExchangeName>
    <dei:EntityEmergingGrowthCompany
      contextRef="C_dbfb670b-9b74-4811-a238-df4dbaefbf50"
      id="F_da75d353-05fb-4589-83dc-85c62c90918b">false</dei:EntityEmergingGrowthCompany>
</xbrl>
